/******************************************
* Insertion des données
******************************************/

/** Inscrivez-vous aux cours en tant qu'étudiant **/
/** Enregistrer personne **/
INSERT INTO personne (nom, prenom, age, sexe, role) VALUES ("Marie", "Dupont", 23, "F", "etudiant");
/** Associer son identifiant à un cours **/
INSERT INTO personne_cours (pc_personne_id, pc_cours_id) VALUES (7,6);
/** Associer son identifiant à un autre cours **/
INSERT INTO personne_cours (pc_personne_id, pc_cours_id) VALUES (7,6);

/** Rajoutez-vous un certificat **/
UPDATE personne SET certificat="IPMA Project Manager Associate" WHERE personne_id=1;

/** Créez un module **/
/** Choisir un identifiant d'un responsable **/
SELECT * FROM personne WHERE role="responsable";
/** Inserer un module **/
INSERT INTO module (description, responsable_id) VALUES ("Interlude 1", 2);

/** Créez deux cours **/
/** Choisir l'identifiant du module **/
SELECT * FROM module;
/** Inserer un cours associé au module par ex. 4 "Interlude 1" **/
INSERT INTO cours (description, module_id, periode) VALUES ("Durabilité du logiciel", 4, "2018-01-23");

/** Créez un professeur et associez-le à un module et à un cours **/
/** Créer un professeur **/
INSERT INTO personne (nom, prenom, age, sexe, role) VALUES ("Nicolas", "Frankel", 33, "M", "professeur");
/** Associer un professeur à un module à travers un cours **/
INSERT INTO personne_cours (pc_personne_id, pc_cours_id) VALUES (7, 1);

/** Créez un étudiant et donnez-lui une note d'examen **/
/** Créer un étudiant **/
INSERT INTO personne (nom, prenom, age, sexe, role, adresse) VALUES ("Catherine", "Fontaine", 27, "F", "etudiant", "Chemin de la prairie 12, 12345 Contamines, France");
/** Associer un étudiant à un cours **/
INSERT INTO personne_cours (pc_personne_id, pc_cours_id) VALUES (8, 1);
/** Associer une note à un identifiant "couple" etudiant-cours **/
INSERT INTO etu_note (etu_note_pc_id, note, date_exa) VALUES (6, 4, "2017-10-30");


/******************************************
* Requetes SQL
*******************************************/

/** Quel sont les étudiants inscrits au cours Versionning (git) ? **/
SELECT * FROM personne, personne_cours, cours WHERE 
personne.role="etudiant" AND 
personne.personne_id=personne_cours.pc_personne_id AND 
personne_cours.pc_cours_id=cours.cours_id AND 
cours.description="Versionning (git)";

/** Quels étudiants ont passé les examens, pour quel cours, à quelle date et quelles sont leur notes ? **/
SELECT nom, prenom, description, date_exa, note FROM personne, personne_cours, cours, etu_note 
WHERE personne.role="etudiant" AND 
personne.personne_id=personne_cours.pc_personne_id AND 
personne_cours.pc_cours_id AND 
personne_cours.pc_id=cours.cours_id AND 
personne_cours.pc_id=etu_note.etu_note_pc_id;

/** Quels modules sont prévus pour 2017 ? **/
SELECT DISTINCT(module.description) FROM cours, module WHERE cours.periode<="2017-12-31" AND cours.module_id=module.module_id;

/** Combien y a-t-il des femmes inscrites ? **/
SELECT COUNT(personne.personne_id) AS femmes FROM personne WHERE personne.sexe="F";

/** Combien y a-t-il des hommes inscrits ? **/
SELECT COUNT(personne.personne_id) AS hommes FROM personne WHERE personne.sexe="H";

/** Quelle est la moyenne générale **/
SELECT AVG(etu_note.note) FROM etu_note;

/** Quel sont les cours sans étudiants inscrits ? **/
/** Recherchons d'abord les identifiants des cours avec les étudiants inscrits **/
SELECT DISTINCT(cours.cours_id) FROM cours, personne_cours, personne WHERE cours.cours_id=personne_cours.pc_cours_id AND personne_cours.pc_personne_id=personne.personne_id AND personne.role!="professeur" AND personne.role!="responnsable";
/** Faisons ensuite une requete impbriquée **/
SELECT cours.cours_id FROM cours WHERE cours.cours_id NOT IN (
SELECT DISTINCT(cours.cours_id) FROM cours, personne_cours, personne WHERE cours.cours_id=personne_cours.pc_cours_id AND personne_cours.pc_personne_id=personne.personne_id AND personne.role!="professeur" AND personne.role!="responnsable"
);

/** Quelles sont les personnes sans adresse **/
SELECT * FROM personne WHERE personne.adresse IS NULL;


/******************************************
* Suppression et manipulation des données
*******************************************/

/** Supprimer un module **/
DELETE FROM module WHERE module_id=4;

/** Supprimer un cours **/
DELETE FROM cours WHERE cours_id=7

/** Supprimer un responsable **/
DELETE FROM personne WHERE personne_id=9

/** Supprimer la table "cours" **/
DROP TABLE cours;

/** Exporter la base de donées e_learning: 
1. utilisez phpmyadmin ou 
2. voir la documentation de mysqldump https://www.digitalocean.com/community/tutorials/how-to-backup-mysql-databases-on-an-ubuntu-vps 
**/

/** Supprimez la base de donées e_learning **/
DROP DATABASE e_lerning;

/** Importez la base de donées e_learning: 
1. utilisez phpmyadmin ou 
2. voir la documentation de l'utilitaire mysql https://www.digitalocean.com/community/tutorials/how-to-backup-mysql-databases-on-an-ubuntu-vps 
**/
